<?php

// connect to db

$db_host = 'localhost';
$db_name = 'db name';
$db_user = 'db user';
$db_pass = 'db password';

$connect_mysql = @mysql_connect($db_host, $db_user, $db_pass);
$connect_db    = @mysql_select_db($db_name,$connect_mysql);

// load library
require_once( './justTable.class.php' );

//  parameters

/// table name
$table_name = 'authors';
/// table columns
$table_columns = array(
  'authors_id',
  'authors_product',
  'authors_author',
  'authors_genre'
);
/// table columns properties :: array ( type, max size, accessibility  )
$table_columns_properties = array(
  array( 'int', 5, false ),
  array( 'string', 255, true ),
  array( 'string', 50, true ),
  array( 'string', 50, true )
);
// type of the check ( in editing )
// -1 is check of all importances
// int >= 0, only specified index
$type_edit_check = 0;

$table_cs_count = count( $table_columns );

/// GET variables
$get_cba_rid    = '_cba_request_id';


// init
$jtable = new justTable( $table_name, $table_columns );

// read get parameters
if ( isset($_GET[$get_cba_rid]) && $_GET[$get_cba_rid] >= 0 )
{
  $cba_id = $_GET[ $get_cba_rid ];
}
else
{
  die ('// Error! Invalid parameters.');
}

  

if (isset( $_GET['edit'] ))
{
  
  /// GET variables
  $get_position   = 'position';
  $get_value      = 'value';
  $get_signs      = 'signs';
  
  // read get parameters
  if ( ( isset($_GET[$get_position]) && $_GET[$get_position] >= 0 ) && $_GET[$get_position] < $table_cs_count ) $position = $_GET[$get_position];
  if ( isset($_GET[$get_value]) ) $value = $_GET[ $get_value ];
  if ( isset($_GET[$get_signs]) && count($_GET[$get_signs]) == $table_cs_count ) $signs = $_GET[ $get_signs ];
  
  // if invalid parameters
  if ( ( !isset($position) || !isset($value) ) || !isset($signs)  ) die ('// Error! Invalid parameters.');
  
  // check variables
  $result = $jtable -> checkVariables( $table_columns_properties, $signs, $value, $position, $type_edit_check );
  if ( $result === true )
  {
    // update
    $jtable -> UpdateCell( $value, $position, $type_edit_check, $signs );
    $answer = $jtable -> CellUpdateStatus( $cba_id, true );
  }
  else
  {
    
    $answer = $jtable -> CellUpdateStatus( $cba_id, $result );
  }
  
  echo $answer;
  exit;
  
}
else
{
  
  /// GET variables
  $get_start      = 'start';
  $get_count      = 'count';
  $get_directions = 'directions';
  $get_column     = 'column';
  
  // read get parameters
  if ( isset($_GET[$get_start]) && $_GET[$get_start] >= 0 ) $start = $_GET[ $get_start ];
  if ( isset($_GET[$get_count]) && $_GET[$get_count] > 0 ) $count = $_GET[ $get_count ];
  $column = ( ( isset($_GET[$get_column]) &&  $_GET[$get_column] >= 0 ) && $_GET[$get_column] < $table_cs_count ) ? $_GET[$get_column] : 0;
  
  // directions
  if ( isset($_GET[$get_directions]) )
  {
    $directions = ( $_GET[$get_directions] > 0 ) ? 1 : 0;
  }
  else
  {
    // default
    $directions = 1;
  }
  
  
  // if invalid parameters
  if ( !isset( $start ) || !isset( $count ) ) die ('// Error! Invalid parameters.');
  
  // read table
  $result = $jtable -> read( $start, $count, $column, $directions );
  
  // result is empty
  if ( count( $result ) == 0 ) die ('// Not Found!');
  
  // convert
  $result = $jtable -> justPhpArrayToJsArray( $result );
  
  // pack to cba-response & write results
  echo $jtable -> justResponseCbaPack( $cba_id , $start, $result );

}


?>